/* This source is placed in the public domain.  Do what you want with it */

extern main();
extern int aor_return;   /* var to determine when through */

void aor(int fdSer, unsigned char decide[]) {

    /* unsigned char decide[22]; */

    /* string to get opcodes and args */
    unsigned char data_opcode[2];
    unsigned char data_delimit, bogus; 
    int decide_byte, up_down_hex, n;

    data_delimit = *"\n";
    n = 2;

    /* initialize the array for loop termination condition */
    while(n<23) {
        decide[n]=*"k";
        n=n+1;
    }
    n=0;

    printf("All parameters are entered without a leading space, i.e. 1A or 1c\n");
    printf("  1)  Search             - Start search in last used search bank or given bank.\n");
    printf("  2)  Scan               - Start scan from last used scan bank or given bank.\n");
    printf("  3)  2 VFO              - 2 VFO mode.\n");
    printf("  4)  VFO                - Single VFO mode.\n");
    printf("  5)  VFO A              - Set to VFO A.\n");
    printf("  6)  Dump Bank          - Dump current or given bank contents.\n");
    printf("  7)  Link Search Banks  - Link any number of search banks (case sensitive).\n");
    printf("  8)  Link Scan Banks    - Link any number of scan banks (case sensitive).\n");
    printf("  9)  Pass               - Set current frequency as PASS (search or scan).\n");
    printf("  u)  UP                 - Up arrow function\n");
    printf("  d)  DOWN               - Down arrow function\n");
    printf(" 99)  Send Specific      - Send specific command via stdin, display any output.\n");
    printf("100)  EX                 - Exit REMOTE and return to keypad control.\n");
    printf("\nPlease input your selection -> ");
    scanf(" %s",decide); 
    decide_byte = atoi(decide);

    /* this figures out if it is up, down or neither */
    if (decide[0] == *"u" || decide[0] == *"d") {
	if (decide[0] == *"u") {
		decide_byte = 1000;
        } else {
		decide_byte = 1001;
	}
    }
    switch(decide_byte)
    {
    case 1:
    data_opcode[0] = *"S";
    data_opcode[1] = *"S";

    n=0;
    while(n<30) {
       printf(decide[n]);
       printf("\n");
       n=n+1;
    }
 
    opcode(fdSer,data_opcode);
    outport(fdSer,decide[1]); 
    outport(fdSer,data_delimit); 
    break;

    case 2:
    data_opcode[0] = *"M";
    data_opcode[1] = *"S";
    opcode(fdSer,data_opcode);
    outport(fdSer,decide[1]); 
    outport(fdSer,data_delimit); 
    break;

    case 3:
    data_opcode[0] = *"V";
    data_opcode[1] = *"F";
    opcode(fdSer,data_opcode);
    outport(fdSer,data_delimit); 
    break;

    case 4:
    data_opcode[0] = *"D";
    data_opcode[1] = *"D";
    opcode(fdSer,data_opcode);
    outport(fdSer,data_delimit); 
    break;

    case 5:
    data_opcode[0] = *"V";
    data_opcode[1] = *"A"; 
    opcode(fdSer,data_opcode);
    outport(fdSer,data_delimit); 
    break;

    case 6:
    data_opcode[0] = *"M";
    data_opcode[1] = *"A";
    opcode(fdSer,data_opcode);
    outport(fdSer,decide[1]); 
    outport(fdSer,data_delimit); 
    readport(fdSer);
    break;

    case 7:
    n = 1;
    data_opcode[0] = *"B";
    data_opcode[1] = *"Q";
    outport(fdSer,decide[0]);
    outport(fdSer,decide[1]);
    outport(fdSer,1);
    outport(fdSer,data_delimit);

    data_opcode[0] = *"B";
    data_opcode[1] = *"S";
    while (decide[n] != *"k") {
      opcode(fdSer,data_opcode);
      outport(fdSer,decide[n]);
      outport(fdSer,data_delimit);
      n=n+1;
    }
    break;
      
    case 8:
    n = 1;
    data_opcode[0] = *"M";
    data_opcode[1] = *"L";
    outport(fdSer,decide[0]);
    outport(fdSer,decide[1]);
    outport(fdSer,1);
    outport(fdSer,data_delimit);

    data_opcode[0] = *"B";
    data_opcode[1] = *"M";
    while (decide[n] != *"k") {
      opcode(fdSer,data_opcode);
      outport(fdSer,decide[n]);
      outport(fdSer,data_delimit);
      n=n+1;
    }
    break;

    case 9:
    data_opcode[0] = *"P";
    data_opcode[1] = *"W";
    opcode(fdSer,data_opcode);
    outport(fdSer,data_delimit);
    break;

    case 99:
    n = 2;
    while (n != 20) {
	outport(fdSer,decide[n]); 
	n = n + 1;
    }
    outport(fdSer,data_delimit); 
    readport(fdSer);
    break;

    case 100:
    data_opcode[0] = *"E";
    data_opcode[1] = *"X";
    opcode(fdSer,data_opcode);
    outport(fdSer,data_delimit); 
    aor_return = 0;
    return; 
    break;

    case 1000:
    up_down_hex = 0x1E;
    outport(fdSer,up_down_hex);
    outport(fdSer,data_delimit); 
    break;

    case 1001:
    up_down_hex = 0x1F;
    outport(fdSer,up_down_hex);
    outport(fdSer,data_delimit); 
    break;

    default:
      printf("Invalid value!!!\n");
    }
}
